import { CompilerType, CSSType, FrameworkType, NpmType } from '@tarojs/binding';
import Creator from './creator';
export interface IPageConf {
    projectDir: string;
    projectName: string;
    npm: NpmType;
    template: string;
    description?: string;
    pageName: string;
    date?: string;
    framework: FrameworkType;
    css: CSSType;
    typescript?: boolean;
    compiler?: CompilerType;
    isCustomTemplate?: boolean;
    customTemplatePath?: string;
}
interface IPageArgs extends IPageConf {
    modifyCustomTemplateConfig: TGetCustomTemplate;
}
interface ITemplateInfo {
    css: CSSType;
    typescript?: boolean;
    compiler?: CompilerType;
    template?: string;
}
type TCustomTemplateInfo = Omit<ITemplateInfo & {
    isCustomTemplate?: boolean;
    customTemplatePath?: string;
}, 'template'>;
export type TSetCustomTemplateConfig = (customTemplateConfig: TCustomTemplateInfo) => void;
type TGetCustomTemplate = (cb: TSetCustomTemplateConfig) => Promise<void>;
export default class Page extends Creator {
    rootPath: string;
    conf: IPageConf;
    private modifyCustomTemplateConfig;
    constructor(args: IPageArgs);
    getPkgPath(): string;
    getPkgTemplateInfo(): any;
    setCustomTemplateConfig(customTemplateConfig: TCustomTemplateInfo): void;
    setTemplateConfig(templateInfo: ITemplateInfo): void;
    fetchTemplates(): Promise<void>;
    create(): Promise<void>;
    write(): void;
}
export {};
